
#property copyright "Martingeil"
#property link      "fx.09@mail.ru"
//  ,         .
//  .
 
//-------   ------------------------------------------
extern int    StopLoss   = 30;     //   StopLoss
extern int    TakeProfit = 100;    //   TakeProfit
extern bool   UseSound       = True;  //   
extern string NameFileSound  = "expert.wav";  //   

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int q;
int init(){
if(Digits==3 || Digits==5) q=10; 
StopLoss = StopLoss * q;
TakeProfit = TakeProfit * q;
return(0);}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() {
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
       if (OrderTakeProfit()==0 || OrderStopLoss()==0) {
      TrailingPositions();
      }
    }
  }
}
 
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void TrailingPositions() {
  double pBid, pAsk, pp, st, tp;
  int digits=MarketInfo(OrderSymbol(),MODE_DIGITS);
  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  
  if (OrderType()==OP_BUY) {   
    pBid = NormalizeDouble(OrderOpenPrice(),digits);
    st   = NormalizeDouble(pBid-StopLoss*pp,digits);
    tp   = NormalizeDouble(pBid+TakeProfit*pp,digits);  
      if (OrderTakeProfit()==0 || OrderStopLoss()==0) {
        ModifyStopLoss(st,tp);
        return;
    }
  }
  if (OrderType()==OP_SELL) {
    pAsk = NormalizeDouble(OrderOpenPrice(),digits);
    st   = NormalizeDouble(pAsk+StopLoss*pp,digits);
    tp   = NormalizeDouble(pAsk-TakeProfit*pp,digits);
      if (OrderTakeProfit()==0 || OrderStopLoss()==0) {
        ModifyStopLoss(st,tp);
        return;
    }//Type
  }//()==0
}//TrailingPositions()
 
//+------------------------------------------------------------------+
//|   StopLoss                                          |
//| :                                                       |
//|   ldStopLoss -  StopLoss                                  |
//+------------------------------------------------------------------+
void ModifyStopLoss(double ldStopLoss,double ldTakeProfit) {
  bool fm;
 
  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,ldTakeProfit,0,CLR_NONE);
  if (fm && UseSound) PlaySound(NameFileSound);
}//ModifyStopLoss
//+------------------------------------------------------------------+